<?php
function wppressuretool_table_exists( $table = 'pressuretool' ) {
	global $wpdb, $wppressuretool;

	if ( 'pressuretool' != $table )
		return false;

	if ( ! $table = $wppressuretool->{$table} )
		return false;

	return strtolower( $wpdb->get_var( "SHOW TABLES LIKE '$table'" ) ) == strtolower( $table );
}

function wppressuretool() {
	global $wpdb, $wppressuretool;

	if ( is_object( $wppressuretool ) )
		return;

	$wppressuretool = (object) array(
		'pressuretool' => $wpdb->prefix . "pressuretool",
		'processing_within' => '',
		'widget_count' => 0,
		'unit_count' => 0,
		'global_unit_count' => 0 );
}

wppressuretool();

/* Loading modules */

add_action( 'plugins_loaded', 'wppressuretool_load_modules', 1 );

function wppressuretool_load_modules() {
	$dir = WPSUPPORTERS_PLUGIN_MODULES_DIR;

	if ( ! ( is_dir( $dir ) && $dh = opendir( $dir ) ) )
		return false;

	while ( ( $module = readdir( $dh ) ) !== false ) {
		if ( substr( $module, -4 ) == '.php' )
			include_once $dir . '/' . $module;
	}
}


function wppressuretool_create_table(){
	global $wpdb, $wppressuretool;
	$table_name = $wpdb->prefix . "pressuretool";
	$sql = "CREATE TABLE IF NOT EXISTS $table_name (
  `pt_id` int(11) NOT NULL auto_increment,
  `sex` varchar(1) NOT NULL,
  `given_name` varchar(50) NOT NULL,
  `surname` varchar(50) NOT NULL,
  `email` varchar(50) NOT NULL,
  `street` varchar(50) NOT NULL,
  `number` varchar(5) NOT NULL,
  `post_code` varchar(5) NOT NULL,
  `city` varchar(100) NOT NULL,
  `verification_code` varchar(100) NOT NULL,
  `changes` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `locked` int(11) NOT NULL,
  `stay_anonymous` int(11) NOT NULL,
  `action` int(11) NOT NULL,
  `people` int(11) NOT NULL,
  `beds` int(11) NOT NULL,
  PRIMARY KEY  (`pt_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$wpdb->query($sql);
}

function wppressuretool_promotion_form($sender,$verification_code){
	/*$content = '
	<h3>Verbreiten Sie diesen Appell!</h3>
	<form id="pressuretool_form" name="pressuretool_form" method="post" action="'.str_replace(array("v=$verification_code","action=save"),"",$_SERVER["REQUEST_URI"].((strpos($_SERVER["REQUEST_URI"],'?')===false)?"?":"&")).'action=promote">
		<input type="hidden" name="sender" id="sender" value="'.$sender.'"/>
		<div class="pressuretool_form_row">
			<label for="recipient">Empf&auml;nger (mehrere bitte mit Komma trennen)</label>
			<input type="text" name="recipient" class="pressuretool_form_input" id="recipient" />
		</div>
		<div class="pressuretool_form_row">
			<label for="given_name">Nachricht</label>
			<textarea name="message" id="message" cols="45" rows="5">
Hallo!

Ich habe den sofortigen Ausstieg aus Stuttgart 21 gefordert (http://'.$_SERVER["HTTP_HOST"].').
Machst Du mit?

			</textarea>
		</div>
		<input type="submit" name="button" id="button" value="Senden" />
	</form>';
	return $content;*/
}
function wppressuretool_promote($sender,$message,$recipient){
	$bcc = "info@".str_replace("www.","",$_SERVER["HTTP_HOST"]);
	$header = 'From: ' .$sender. "\r\n" .
    'Bcc: ' .$bcc. "\r\n" .
    'Reply-To: ' .$sender. "\r\n" .
    'X-Mailer: Microsoft Office Outlook, Build 11.0.5510 \r\n' .
	'MIME-Version: 1.0 \r\n'.
    'Content-type: text/html; charset=utf-8 \r\n';
	$subject = $_SERVER["HTTP_HOST"];
	$resmail = wp_mail($recipient,$_SERVER["HTTP_HOST"],$message,$header);
	$content = ($resmail)?"<p><strong>Vielen Dank f&uuml;r Deine Weiterleitung.</strong></p>":"<p><strong>Fehler beim Versenden.</strong></p>";
	return $content;
}
function send($user){
	global $subject;
	global $text;
	$recipients = wppressuretool_recipients();
	$bcc = "info@".str_replace("www.","",$_SERVER["HTTP_HOST"]);
	$header = 'From: ' .$user->given_name." ".$user->surname." <".$user->email."> \r\n" .
    'Bcc: ' .$bcc. "\r\n" .
    'Reply-To: ' .$user->email. "\r\n" .
    'X-Mailer: Microsoft Office Outlook, Build 11.0.5510 \r\n' .
	'MIME-Version: 1.0 \r\n'.
    'Content-type: text/html; charset=utf-8 \r\n';
	foreach ($recipients as $to){
		//echo $header.$subject.$to->email.$to->anrede."&nbsp;".$to->titel."&nbsp;".$to->nachname.",\r\n\r\n".$text."\r\n\r\n".$user->given_name." ".$user->surname;
		wp_mail($to->email,$subject,$to->anrede." ".$to->titel." ".$to->nachname.",\r\n\r\n".str_replace(array("<p>","</p>","<br />"),array("","\r\n",""),$text)."\r\n\r\n".$user->given_name." ".$user->surname,$header);
		//exit;
	}	
}

function wppressuretool_registration($preselect=false){
	global $wpdb;
	$sender = "info@".str_replace("www.","",$_SERVER["HTTP_HOST"]);
	$header = 'From: Bei Abriss Aufstand <'.$sender.">\r\n" .
    'Bcc: ' .$sender. "\r\n" .
    'Reply-To: ' .$sender. "\r\n" .
    'X-Mailer: Microsoft Office Outlook, Build 11.0.5510';
	$content = "";
	if(isset($_GET['v'])){
		$pt_id = (int)$_GET['id'];
		$verification_code = (int)$_GET['v'];
		$sql = "SELECT * FROM ".$wpdb->prefix."pressuretool WHERE pt_id = $pt_id AND verification_code = $verification_code";
		$res = $wpdb->get_results($sql,OBJECT);
		if($wpdb->num_rows==1){
			$wpdb->update( $wpdb->prefix.'pressuretool', array( 'locked' => '0', 'verification_code' => '' ), array( 'pt_id' => $pt_id ));
			send($res[0]);
			$content = "<p>Danke. Wir haben Ihren Appell jetzt verschickt.</p>";
			//echo $res[0]->email;
			$content.= wppressuretool_promotion_form($res[0]->email,$verification_code);
		}
		else
			$content = "<p>Bei der Verifizierung ist ein <strong>Fehler</strong> aufgetreten.</p>";
	}
	elseif(isset($_GET['action'])){
		if($_GET['action'] == 'save' && $_POST != array()){
			//echo "<div style='color:#fff'>".print_r($_POST,true)."</div>";
			$sex = $wpdb->escape(($_POST['sex']=="m")?"m":"f");
			$given_name = $wpdb->escape($_POST['given_name']);
			$surname = $wpdb->escape($_POST['surname']);
			$email = $wpdb->escape($_POST['email']);
			$street = $wpdb->escape($_POST['street']);
			$number = $wpdb->escape($_POST['number']);
			$post_code = $wpdb->escape($_POST['post_code']);
			$city = $wpdb->escape($_POST['city']);
			$locked = 1;
			$verification_code = round(rand(1000000,9999999));
			$stay_anonymous = (isset($_POST['stay_anonymous']) && $_POST['stay_anonymous'] == '1')?1:0;
			//$stay_anonymous = ($_POST['stay_anonymous']=='1')?1:0;
			$action = (int)$_POST['action'];
			$people = (int)$_POST['people'];
			$beds = (int)$_POST['beds'];
			$sql = "SELECT pt_id FROM ".$wpdb->prefix."pressuretool WHERE email = '$email'";
			//echo $sql;
			$res = $wpdb->get_results($sql,OBJECT);
			if($wpdb->num_rows==0 && strpos($email,"@")>0 && strpos($email,".")!==0){
				//echo "a ";
				$wpdb->insert( $wpdb->prefix . 'pressuretool', array( 'sex' => $sex,
												   'given_name' => $given_name,
												   'surname' => $surname,
												   'email' => $email,
												   'street' => $street,
												   'number' => $number,
												   'post_code' => $post_code,
												   'city' => $city,
												   'stay_anonymous' => $stay_anonymous,
												   'action' => $action,
												   'people' => $people,
												   'beds' => $beds,
												   'locked' => $locked,
												   'verification_code' => $verification_code));
				if($wpdb->insert_id!==false){
					//echo "b ";
					$message = "Hallo $given_name $surname,\r\n\r\n bitte bestätigen Sie Ihren Eintrag auf ".$_SERVER["HTTP_HOST"].", indem Sie auf den folgenden Link klicken: http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"].((strpos($_SERVER["REQUEST_URI"],'?')===false)?"?":"&")."v=".$verification_code."&id=".$wpdb->insert_id;
					$subject = $_SERVER["HTTP_HOST"]." - Verifizierung";
					//echo $email." ".$subject." ".$message." ".$header;
					$resmail = wp_mail($email,$subject,$message,$header);
					$content = ($resmail)?"<p><strong>Vielen Dank f&uuml;r Ihr Engagement.<br/>Wir haben Ihnen eine E-Mail zur Verifizierung Ihrer E-Mail-Adresse geschickt. Klicken Sie auf den Link in der E-Mail und wir verschicken Ihren Appell.</strong></p>":"<p><strong>Fehler beim Versenden der Best&auml;tigungs-E-Mail.</strong></p>";
				}
				$_POST = array();
				$email = "";
			}
			else{
				$content = "<p><strong>Sie haben leider schon teilgenommen.</strong></p>";
				$_POST = array();
			}
		}
		elseif($_GET['action'] == 'promote' && $_POST != array()){
			//echo "promote";
			$id = (int)$_GET['id'];
			$sql = "SELECT email FROM ".$wpdb->prefix."pressuretool WHERE pt_id = '$id'";
			$res = $wpdb->get_results($sql,OBJECT);
			//echo $wpdb->num_rows;
			if($wpdb->num_rows==1){
				$sender = $res[0]->email;
				$message = $wpdb->escape($_POST['message']);
				$recipient = $wpdb->escape($_POST['recipient']);
				if(strpos($recipient,"@")!==false)
					$content = wppressuretool_promote($sender,$message,$recipient);
				else
					$content = "<p><strong>Danke f&uuml;r Ihre Weiterleitung. Leider haben Sie keinen Empf&auml;ner eingetragen.</strong></p>";
				//echo "$sender,$message,$recipient";
				
			}
		}
	}
	else
		$content = wppressuretool_form($preselect);
	return $content;
}

/**
 * @param string $mode (camp, support, action)
 */

function wppressuretool_form($mode=false){
	$content = 'Die Aktion ist abgelaufen. Vielen Dank an alle, die mitgemacht haben.';
	/*$content = '
	<form id="pressuretool_form" name="pressuretool_form" method="post" action="'.$_SERVER["REQUEST_URI"].((strpos($_SERVER["REQUEST_URI"],'?')===false)?"?":"&").'action=save">
		';*/
	/*
	if($mode=="support")
		$content.='<input type="hidden" name="action" id="action" value="0"/>';
	elseif($mode=="action")
		$content.='<input type="hidden" name="action" id="action" value="1"/>';
	elseif($mode=="camp")
		$content.='<input type="hidden" name="action" id="action" value="2"/>';
	else
	$content.='
		<div class="pressuretool_form_row">
			<label for="action">Art der Erkl&auml;rung</label>
			<select name="action" id="action" class="pressuretool_form_input">
				<option value="1">Aktivist/in</option>
				<option value="0" selected>Unterst&uuml;tzer/in</option>
			</select>
		</div>';
	*/
	/*$content.='
		<!--<div class="pressuretool_form_row">
			<label for="sex">Anrede</label>
			<select name="sex" id="sex" class="pressuretool_form_input">
				<option value="m">Herr</option>
				<option value="f" selected>Frau</option>
			</select>
		</div>-->
		<div class="pressuretool_form_row">
			<label for="given_name">Vorname</label>
			<input type="text" name="given_name" class="pressuretool_form_input" id="given_name" />
		</div>
		<div class="pressuretool_form_row">
			<label for="surname">Nachname</label>
			<input type="text" name="surname" class="pressuretool_form_input" id="surname" />
		</div>';
	if($mode!="camp") $content.='
		<!--<div class="pressuretool_form_row">
			<label for="stay_anonymous">Anonymisieren</label>
			<input name="stay_anonymous" type="checkbox" value="1" />
			( = nur Deinen Vorname und den ersten Buchstabe Deines Nachnamens ver&ouml;ffentlichen)
		</div>-->';
	if($mode=="camp") $content.='
		<!--<div class="pressuretool_form_row">
			<label for="people">Anzahl der Personen</label>
			<input type="text" name="people" class="pressuretool_form_input" id="people" />
		</div>
		<div class="pressuretool_form_row">
			<label for="beds">Ben&ouml;tigte Schlafpl&auml;tze</label>
			<input type="text" name="beds" class="pressuretool_form_input" id="beds" />
		</div>-->';
	$content.='
		<!--<div class="pressuretool_form_row">
			<label for="post_code">Postleitzahl</label>
			<input type="text" name="post_code" class="pressuretool_form_input" id="post_code" />
		</div>
		<div class="pressuretool_form_row">
			<label for="city">Stadt</label>
			<input type="text" name="city" class="pressuretool_form_input" id="city" />
		</div>-->
		<div class="pressuretool_form_row">
			<label for="email">E-Mail-Adresse</label>
			<input type="text" name="email" class="pressuretool_form_input" id="email" />
		</div>
		<input type="submit" name="button" id="button" value="Abschicken!" />
	</form>';
	//phpinfo();*/
	return $content;
}

function fix_anonymous(){
	global $wpdb;
	/*$sender = "info@".str_replace("www.","",$_SERVER["HTTP_HOST"]);
	//echo $sender;
	$header = 'From: ' .$sender. "\r\n" .
    'Bcc: ' .$sender. "\r\n" .
    'Reply-To: ' .$sender. "\r\n" .
    'X-Mailer: Microsoft Office Outlook, Build 11.0.5510';
	//echo $header;
	$sql = "SELECT *
			FROM  `".$wpdb->prefix."pressuretool` 
			WHERE `changes`< '2011-03-16 14:07:21'
			ORDER BY pt_id";
	$results = $wpdb->get_results($sql,OBJECT);
	//print_r($results);
	$content = "";
	
	$result = $results[0];
	foreach($results as $result){
		//print_r($result);
		$verification_code = round(rand(1000000,9999999));
		$content.= "mail ".$result->email."<br/>";
		mail($result->email,str_replace("www.","",$_SERVER["HTTP_HOST"])." entschuldigt sich vielmals","Hallo ".$result->given_name." ".$result->surname.",\r\n\r\nwir hatten leider Probleme mit der Anonymisierung der Nachnamen und haben deshalb alle Eintraege auf 'anonymisiert' gesetzt.\r\n\r\nWenn Du Deinen Nachnamen oeffentlich sichtbar machen willst, klicke auf den folgenden Link: http://".$_SERVER["HTTP_HOST"]."/fix?id=".$result->pt_id."&a=".$verification_code,$header);
		$res = $wpdb->update( $wpdb->prefix.'pressuretool', array( 'verification_code' => $verification_code, 'stay_anonymous' => 1 ), array( 'pt_id' => $result->pt_id ));
	}

	return $content;*/
}
function pressuretool_anonymoustopublic($content){
	global $wpdb;
	$content = "";
	$verification_code = (int)$_GET["a"];
	$pt_id = (int)$_GET["id"];
	$sql = "SELECT pt_id FROM ".$wpdb->prefix."pressuretool WHERE pt_id = $pt_id AND verification_code = $verification_code";
	$res = $wpdb->get_results($sql,OBJECT);
	if($wpdb->num_rows==1){
		$wpdb->update( $wpdb->prefix.'pressuretool', array( 'stay_anonymous' => 0 , 'verification_code' => ''), array( 'pt_id' => $pt_id , 'verification_code' => $verification_code));
		$content = "<p>Danke, dass Du Dich &ouml;ffentlich zu unserer Aktion bekennst.</p>";
	}
	else{
		$content = "<p>Fehler bei Freischaltung Deines Nachnamens</p>";
	}
	return $content;
}

/**
 * @param string $mode (camp, support, action)
 */

function wppressuretool_listing($mode=false,$just_count=false){
	global $wpdb;
	if($mode=="action")
		$mode = 1;
	elseif($mode=="camp")
		$mode = 2;
	else
		$mode = 0;
	$sql = "SELECT given_name, surname, city, stay_anonymous FROM ".$wpdb->prefix."pressuretool WHERE locked = 0 AND action = $mode ORDER BY pt_id DESC";
	$results = $wpdb->get_results($sql,OBJECT);
	$content = "";
	$number = $wpdb->num_rows;
	if($just_count)
		$content = $number;
	else{
		foreach ($results as $row) {
			//$row->stay_anonymous = 1;
			$content.= "<div class='supporter'><span class='pt_number'>".$number."</span><span class='pt_name'>".$row->given_name."&nbsp;".(($row->stay_anonymous == 1)?substr($row->surname,0,1).".":$row->surname)."</span><span class='pt_city'>".$row->city."</span></div>";
			$number--;
		}
		$content.= "<div class='supporter'></div>";
	}
	return $content;
}
add_action('wp_head','wppressuretool_counter');
/**
 *
 */
function wppressuretool_counter_replace(){
	global $wpdb;
	$sql = "SELECT given_name FROM ".$wpdb->prefix."pressuretool WHERE locked = 0";
	$results = $wpdb->get_results($sql,OBJECT);
	$number = $wpdb->num_rows;
	return $number;
}

/**
 * 
 */
function wppressuretool_counter() {
	return wppressuretool_listing("action",true);
}

function wppressuretool_font_scale(){
	$counter = "".wppressuretool_listing("action",true);
	$count = array();
	$count[0] = substr_count ($counter, "0");
	$count[1] = 0.7 * substr_count ($counter, "1");
	$count[2] = substr_count ($counter, "2");
	$count[3] = substr_count ($counter, "3");
	$count[4] = substr_count ($counter, "4");
	$count[5] = substr_count ($counter, "5");
	$count[6] = substr_count ($counter, "6");
	$count[7] = substr_count ($counter, "7");
	$count[8] = substr_count ($counter, "8");
	$count[9] = substr_count ($counter, "9");
	return array_sum($count);
}
/**
 *
 */
function wppressuretool_recipients(){
	global $wpdb;
	$sql = "SELECT * FROM abgeordnete ORDER BY nachname";
	$res = $wpdb->get_results($sql,OBJECT);
	return $res;
}
/**
 *
 */
function wppressuretool_recipients_html(){
	$data = wppressuretool_recipients();
	$content = "";
	foreach ($data as $row) {
		$content.= str_replace(array("Sehr geehrte ", "Sehr geehrter "),"",$row->anrede)."&nbsp;".$row->title."&nbsp;".$row->nachname.",&nbsp;".$row->partei."; ";
	}
	return $content;
}
/**
 * 
 * @param string $content
 * @return string
 */
function wppressuretool_text($content){
	global $text;
	global $subject;
	$subject = substr($content,strpos($content,'[subject_start]')+strlen('[subject_start]'));
	$subject = substr($subject,0,strpos($subject,'[subject_end]'));
	$text = substr($content,strpos($content,'[pressuretool_text_start]')+strlen('[pressuretool_text_start]'));
	$text = substr($text,0,strpos($text,'[pressuretool_text_end]'));
	$content = str_replace('[pressuretool_text_start]',"",$content);
	$content = str_replace('[pressuretool_text_end]',"",$content);
	$content = str_replace('[subject_start]',"<strong>",$content);
	$content = str_replace('[subject_end]',"</strong>",$content);
	return $content;
}

/**
 * @return string Dummymail
 */
function dummytext(){
	$anrede = "Sehr geehrte/r XY";
	return text($anrede);
}
/**
 * @param string $anrede
 * @return string fertiger Text
 */
function text($anrede){
	$mytext = "";
	return $anrede.$mytext;
}

add_filter('the_content', 'wppressuretool_content');

function wppressuretool_content($content) {
	if(strpos($content,'[pressuretool')!==false){
		if(!wppressuretool_table_exists()){
			wppressuretool_create_table();
		}
		if(strpos($content,'[pressuretool_recipients]')!==false)
			$content = str_replace('[pressuretool_recipients]',wppressuretool_recipients_html(),$content);
		if(strpos($content,'[pressuretool_text_start]')!==false && strpos($content,'[pressuretool_text_end]')!==false)
			$content = wppressuretool_text($content);
		$content = str_replace('[pressuretool]',wppressuretool_listing("support"),$content);
		$content = str_replace('[pressuretool_counter]',wppressuretool_counter_replace(),$content);
		$content = str_replace('[pressuretool_activists]',wppressuretool_listing("action"),$content);
		$content = str_replace('[pressuretool_camp]',wppressuretool_listing("action"),$content);
		if(strpos($content,'[pressuretool_anonymoustopublic]')!==false)
			$content = str_replace('[pressuretool_anonymoustopublic]',pressuretool_anonymoustopublic(),$content);
		if(strpos($content,'[pressuretool_internal_fix]')!==false)
			$content = str_replace('[pressuretool_internal_fix]',fix_anonymous(),$content);
		if(strpos($content,'[pressuretool_form]')!==false){
			if(isset($_GET['action']))
				$content = wppressuretool_registration();
			else
				$content = str_replace('[pressuretool_form]',wppressuretool_registration(),$content);
		}
		/*
		if(strpos($content,'[pressuretool_form_support]')!==false)
			$content = str_replace('[pressuretool_form_support]',wppressuretool_registration("support"),$content);
		if(strpos($content,'[pressuretool_form_activist]')!==false)
			$content = str_replace('[pressuretool_form_activist]',wppressuretool_registration("action"),$content);
		if(strpos($content,'[pressuretool_form_camp]')!==false)
			$content = str_replace('[pressuretool_form_camp]',wppressuretool_registration("camp"),$content);
		*/
	}
	return $content;
}
?>